;	M4LOG/ASM
;	LOGON SCRIPT INTERPRETER
;	OUTPUT STRING TO PORT
SOUSND	LD	A,CMTXT			;GET SOME TEXT TO SEND
	LD	DE,DATA			;WHERE TO PUT THE STRING
	LD	(SOUPTR),DE		;SET THE ORIGINAL DATA ADDRESS
	CALL	COMND			;GET IT
	JP	KERMT3			;SAY NOT CONFIRMED ON ERROR
	LD	A,1
	LD	(SNDFLG),A
SOU020	CALL	GETFCH			;GET A CHARACTER
	JR	NZ,SOU030
	CALL	GTREAL			;GET THE ACTUAL IF IT IS SPECIAL
	JP	NZ,SOU400		;QUIT ON AN ERROR
	LD	E,A			;PUT IT IN E FOR OUTCHR
	LD	A,(DLYFLG)		;WAS IT A DELAY
	OR	A			;SET THE FLAGS
	JR	Z,SOU022		;JUMP IF NO DELAY
	XOR	A
	LD	(DLYFLG),A		;RESET THE FLAG
	JR	SOU020			;GET A NEW CHARACTER
SOU022	CALL	OUTCHR			;OUT THE PORT WITH IT
	LD	A,(LOGFLG)		;DO WE NEED TO LOGIT TO THE FILE
	OR	A
	LD	A,E			;RESTORE THE CHARACTER IN A
	CALL	NZ,LOGIT		;LOG IT IF LOGFLG IS SET
	CP	32			;WAS IT A CONTROL CHARACTER
	JR	C,SOU020		;MACHINES DON'T ECHO CONTROLS
	LD	A,(ECHFLG)		;IS ECHO ON?
	OR	A
	JR	Z,SOU020		;IF NOT THAN GET THE NEXT TO SEND
	LD	A,E			;GET THE CHARACTER BACK IN A
	PUSH	AF			;SAVE IT FOR A SEC
SOU025	CALL	INPORT			;GET ONE CHARACTER FROM THE PORT
	JR	Z,SOU028		;GOT ONE SO PROCESS IT
	CALL	CONIN			;IS THERE A KEY PRESSED?
	OR	A			;SET THE FLAGS
	JR	Z,SOU025		;GO IF THERE ISN'T
	CP	128			;IS IT BREAK
	JP	Z,SBORT			;QUIT IF IT IS
	CP	27			;IS IT ESCAPE
	JP	Z,QUTOUT		;CLOSE AND SURRENDER THE TERMINAL
	CP	129			;CHECK FOR F1 PRESSED
	JP	Z,QUTOUT		;CLOSE AND SURRENDER THE TERMINAL
	JP	SOU025			;TRY AGAIN TO GET THE ECHO
SOU028	LD	E,A
	LD	A,(OTDSP)		;LOCAL ECHO ON?
	OR	A
	LD	A,E			;RESTORE A FOR THE CALL TO CONOUT
	CALL	NZ,CONOUT		;DISPLAY THE CHARACTER
	LD	A,(LOGFLG)		;IS LOGGING SET?
	OR	A
	LD	A,E
	CALL	NZ,LOGIT		;LOG WHAT WE RECEIVED
	CALL	SETCSE			;SET THE CASE
	LD	E,A			;PUT IT IN E
	POP	AF			;GET THE CHARACTER WE SENT
	CALL	SETCSE			;SET THE CASE
	CP	E			;ARE THEY THE SAME
	JR	Z,SOU020		;BETTER BE OR QUIT
	LD	DE,NOECHO		;LOAD NO REMOTE-HOST ECHO ERROR
	JP	SBORT2			;QUIT, NO MATCH
SOU030	XOR	A			;RESET STATE FLAG
	LD	(SNDFLG),A
	JP	KERMIT			;GET A NEW COMMAND
FLINK	DEFS	256			;FAILURE LINK STORAGE
STRING	DEFS	256			;STORAGE FOR THE STRING TO MATCH
LENGTH	DEFB	0			;LENGTH OF STRING
;	Do receive character matching.
SOUREC	LD	A,CMTXT			;GET SOMETHING TO SEND
	LD	DE,DATA			;WHERE TO PUT THE TEXT
	LD	(SOUPTR),DE		;SAVE THE ADDRESS FOR GETFCH
	CALL	COMND			;GET SOME TEXT, OR FAIL
	JP	KERMT3			;SAY NOT CONFIRMED ON FAILURE
	LD	A,1
	LD	(RECFLG),A
	LD	HL,STRING		;GET ADDRESS OF THE BUFFER
	LD	B,0			;B IS THE LENGTH COUNTER
SOU040	CALL	GETFCH			;GET A CHARACTER
	JP	NZ,SOU043		;QUIT ON AN ERROR
	CALL	GTREAL			;CONVERT ESCAPES, ETC...
	JP	NZ,SOU400		;QUIT ON AN ERROR
	LD	E,A			;SAVE THE CHARACTER FOR A SEC
	LD	A,(DLYFLG)		;WAS IT A DELAY?
	OR	A			;SET THE FLAGS
	JR	Z,SOU042		;JUMP IF NOT
	XOR	A			;CLEAR A
	LD	(DLYFLG),A		;RESET THE FLAG
	JR	SOU040
SOU042	LD	(HL),E			;STORE WHAT WE GOT
	INC	HL			;POINT TO THE NEXT
	INC	B			;ONE MORE TO LENGTH
	JR	NZ,SOU040		;JUMP IF NOT BUFFER OVERFLOW
	LD	DE,STOBIG		;LOAD MESSAGE STRING
	CALL	PRTSTR			;PRINT IT ON THE SCREEN.
	JP	SOU540			;LOOK FOR TAKE ACTIVE
SOU043	LD	(HL),0			;END IT WITH A NULL
	LD	A,B			;B IS THE LENGTH
	LD	(LENGTH),A		;SAVE THE LENGTH M=STRLEN(STR)
	XOR	A			;ZERO A FOR FLINK[1]=0
	LD	C,1			;SUBSCRIPT 1
	CALL	SETLNK			;FLINK[1]=0;
	LD	D,2			;I=2;
;	SET UP FAILURE LINK TABLE FOR KMP PATTERN MATCHING ALGORYTHM
SOU045	LD	C,D			;GET I
	LD	A,(LENGTH)		;GET THE LENGTH OF THE STRING
	CP	C			;IF (I <= M)
	JP	M,SOU060		;JUMP IF PAST END OF STRING
	LD	C,D			;C = I
	DEC	C			;C = I-1
	CALL	GETLNK			;A = FLINK[c]
	LD	E,A			;J = FLINK[I-1]
SOU050	INC	E			;IF (I != 0
	DEC	E
	JR	Z,SOU055		;JUMP IF I = 0
	LD	C,E			;C = J
	CALL	GETSTG			;A = STRING[J]
	LD	B,A			;B = A
	LD	C,D			;C = I
	DEC	C			;C = I - 1
	CALL	GETSTG			;A = STRING[I-1]
	CP	B			;IF (STRING[J] != STRING[I-1])
	JR	Z,SOU055		;JUMP IF EQUAL
	LD	C,E			;C = J
	CALL	GETLNK			;A = FLINK[J]
	LD	E,A			;J = FLINK[J]
	JR	SOU050
SOU055	LD	A,E			;A = J
	INC	A			;A = J+1
	LD	C,D			;C = I
	CALL	SETLNK			;FLINK[I] = J+1
	INC	D			;I++
	JR	SOU045
SOU060	LD	E,0			;J = 0
	LD	A,(HSTCHR)		;GET ANY LEFT OVER CHARACTERS
	OR	A
	JR	Z,SOU076
	LD	C,A			;SAVE A FOR A SEC
	XOR	A			;CLEAR IT OUT
	LD	(HSTCHR),A		;SAY NO REMAINING HOST CHARACTER
	LD	A,C			;RESTORE A
SOU063	LD	(CHRGOT),A
	LD	C,A			;SAVE THE CHARACTER
	LD	A,(INDSP)		;CHECK IF WE SHOULD DISPLAY
	OR	A
	JR	Z,SOU068		; GO IF NOT
	LD	A,C			; GET THE CHARACTER BACK
	CP	32			; CHECK IF CONVERSION NEEDED
	JR	NC,SOU067		; GO IF NONE NEEDED
	PUSH	BC			;CONVERT INCOMMING <CR><LF> TO 
	PUSH	HL			; THE PROPER CHR$(29) CHR$(10)
	LD	B,0			; ZERO THE MSB
	LD	HL,TRTAB		; GET THE TABLE
	ADD	HL,BC			; GET THE TABLE ADDRESS
	LD	A,(HL)			; GET THE NEW CHARACTER
	POP	HL			; RESTORE THE REGS
	POP	BC
SOU067	CALL	CONOUT			;PRINT IT
SOU068	LD	A,(LOGFLG)		;IS LOGGING ON
	OR	A			;SET THE FLAGS
	LD	A,C			;RESTORE THE CHARACTER INTO A
	CALL	NZ,LOGIT		;LOG THE CHARACTER TO THE FILE
	INC	E			;++J
SOU070	INC	E			;IS E == 0
	DEC	E
	JR	Z,SOU075
	LD	C,E			;C = J
	DEC	C			;C = J-1
	CALL	GETSTG			;A = STRING[J-1]
	CALL	SETCSE			;ADJUST THE CASE
	LD	C,A			;C = A
	LD	A,(CHRGOT)
	CALL	SETCSE			;ADJUST THE CASE
	CP	C			;STR[J-1] != C
	JR	Z,SOU075		;JUMP IT IS EQUAL (A MATCH!)
	LD	C,E			;C = J
	CALL	GETLNK			;A = FLINK[J]
	LD	E,A			;J = FLINK[J]
	JR	SOU070
SOU075	LD	A,(LENGTH)		;ARE WE AT THE END
	CP	E			;IF(J == M) QUIT
	JR	Z,SOU080		;EXIT IF WE FOUND IT
SOU076	CALL	INPORT			;GET A CHARACTER IF THERE
	JR	Z,SOU063		;GO IF WE GOT ONE
	CALL	CONIN			;IS THERE A KEY PRESSED
	OR	A			;SET THE FLAGS
	JR	Z,SOU076		;JUMP IF NONE
	CP	128			;IS BREAK PRESSED
	JP	Z,SBORT			;SBORT IF IT IS
	CP	ESC			;IS IT ESCAPE
	JP	Z,QUTOUT		;CLOSE AND SURRENDER THE TERMINAL
	CP	129			;CHECK IF F1 IS PRESSED AS ESCAPE
	JP	Z,QUTOUT		;QUIT AND SURRENDER THE TERMINAL
	PUSH	DE			;SAVE E
	LD	E,A			;OUTCHR NEEDS CHAR IN E
	CALL	OUTCHR			;SEND IT OUT THE PORT
	POP	DE			;RESTORE E
	JR	SOU076			;CHECK AGAIN
SOU080	XOR	A			;RESET RECEIVE STATE FLAG
	LD	(RECFLG),A
	JP	KERMIT			;GET A NEW COMMAND
;	DO MULTIPLE/REPEATING TRANSMITTION UNTIL A CHARACTER IS RECEIVED
BUFPTR	DEFW	0			;POINTER INTO THE BUFFER
MULBUF	DEFS	100H			;THE BUFFER
SOUMUL	LD	A,CMTXT			;GET SOME TEXT
	LD	DE,DATA			;WHERE TO PUT IT
	LD	(SOUPTR),DE		;SAVE THE ADDRESS OF THE BUFFER
	CALL	COMND			;GET SOME TEXT
	JP	KERMT3			;SAY NOT CONFIRMED ON FAILURE
	LD	A,1
	LD	(MULFLG),A
	LD	HL,MULBUF		;GET THE BUFFER
	LD	(BUFPTR),HL		;SAVE THE START
SOU100	CALL	GETFCH			;GET A CHARACTER
	JP	NZ,SOU110		;QUIT ON AN ERROR
	CALL	GTREAL			;GET THE ACTUAL CHARACTER
	JP	NZ,SOU400
	LD	E,A
	LD	A,(DLYFLG)		;WAS IT A DELAY?
	OR	A
	JR	Z,SOU103		;JUMP IF NOT
	XOR	A			;CLEAR A
	LD	(DLYFLG),A		;RESET THE FLAG
	JR	SOU100			;GET A NEW CHARACTER
SOU103	LD	(HL),E			;SAVE THE CHARACTER
	INC	HL			;POINT TO THE NEXT
	JR	SOU100			;DO IT AGAIN
SOU110	LD	(HL),A			;SAVE THE ')' JUST FOUND
	INC	HL			;POINT TO THE NEXT CHARACTER
	XOR	A			;CLEAR A
	LD	(HL),A			;TERMINATE WITH A NULL
SOU120	LD	BC,3000			;DELAY COUNTER, MAGICAL NUMBER?!?
SOU130	CALL	INPORT			;CHECK FOR A CHARACTER FIRST.
	JR	Z,SOU150		;GO IF WE GOT ONE
	PUSH	BC			;SAVE BC
	CALL	CONIN			;CHECK THE KEYBOARD
	OR	A
	JR	Z,SOU133		;GO IF NO CHAR
	CP	128			;IS IT BREAK?
	POP	BC
	JP	Z,SBORT			;SBORT IF IT IS
	CP	ESC			;IS IT ESCAPE?
	JP	Z,QUTOUT		;QUIT AND SURRENDER THE TERMINAL
	CP	129			;IS F1 PRESSED FOR ESCAPE?
	JP	Z,QUTOUT		;QUIT AND SURRENDER THE TERMINAL
	PUSH	BC
	LD	E,A			;PUT CHAR IN E FOR OUTCHR
	CALL	OUTCHR			;OUTPUT THE SUCKER!
	LD	A,(LOGFLG)		;CHECK FOR LOGGING TO FILE
	OR	A
	LD	A,E			;GET THE CHARACTER BACK
	CALL	NZ,LOGIT		;GO LOG IT TO THE FILE IF FLAG
SOU133	POP	BC
	DEC	BC			;DECREMENT OUR COUNTER
	LD	A,B			;CHECK IT FOR ZERO
	OR	C
	JR	NZ,SOU130		;LOOP UNTIL IT IS
	LD	HL,MULBUF		;GET THE STRING ADDRESS
SOU140	LD	A,(HL)			;GET A CHARACTER TO SEND
	CP	CR			;IS IT THE END OF THE STRING?
	JR	NZ,SOU143		;IF NOT ')' THAN JUMP
	INC	HL			;CHECK FOR NULL TERMINATOR
	LD	A,(HL)			;GET THE CHARACTER AFTER ')'
	DEC	HL			;POINT BACK ONE FOR FAIL
	OR	A			;IS IT A NULL?
	JR	Z,SOU120		;IF SO THAN END OF STRING
SOU143	INC	HL			;POINT TO NEXT CHAR
	PUSH	HL			;SAVE THE ADDRESS
	LD	E,A			;SEND IT TO THE PORT
	CALL	OUTCHR
	LD	A,(LOGFLG)		;CHECK FOR LOGGING
	OR	A
	LD	A,E			;GET THE CHARACTER BACK
	CALL	NZ,LOGIT		;GO LOG IT TO THE FILE
	POP	HL			;GET THE ADDRESS BACK
	JR	SOU140			;TO OF THE LOOP
SOU150	LD	(HSTCHR),A		;SAVE THE SENT CHARACTER
	XOR	A			;RESET THE STATE FLAG
	LD	(MULFLG),A
	JP	KERMIT			;GET A NEW COMMAND
;	PAUSE FOR A CERTAIN NUMBER OF SECONDS
SOUPSE	LD	A,CMNUM			;GET A WHILE TO PAUSE
	CALL	COMND			;GET A NUMBER
	JP	KERMT3			;SAY NOT CONFIRMED ON AN ERROR
	OR	A			;CHECK FOR NO NUMBER
	JR	NZ,SPSE10
	LD	DE,1			;ONE SECOND DEFAULT
SPSE10	LD	L,E			;SAVE IT
	LD	H,D			;HL IN THE COUNT
	LD	C,30			;33.33 MILLISECS * 30 * HL = SECS
	LD	A,91
	RST	28H			;HL & A = HL * 30
	LD	H,L			;SHIFT IT ALL INTO HL
	LD	L,A			;HL = HL * 120
	LD	(TIMER),HL		;STORE THE NUMBER
	LD	A,29			;@ADTSK SVC
	LD	C,8			;TASK SLOT # 8
	LD	DE,ALRMAD		;ADDRESS OF THE ALARM
	RST	28H
SPSE20	LD	HL,(TIMER)		;CHECK FOR ZERO YET
	LD	A,H
	OR	L
	JR	NZ,SPSE20		;LOOP UNTIL EXPIRES
	JP	KERMIT			;QUIT WHEN FLAG IS ZERO
;	Set or ignore case based on "CSEFLG"
SETCSE	PUSH	AF			;SAVE THE CHARACTER
	LD	A,(CSEFLG)		;IS THE OPTION ON?
	OR	A
	JR	Z,CPS10			;JUMP IF IT IS NOT!!!
	POP	AF			;GET THE CHARACTER BACK
CPTAL	CP	'a'			;CHECK FOR LOWER CASE
	RET	M
	CP	'z'+1
	RET	P
	AND	5FH			;MAKE IT UPPER IF IT IS LOWER
	JR	CAPS20
CPS10	POP	AF			;RESTORE AF
CAPS20	RET				;RETURN TO THE CALLER
;	INDEX STRING BY "C" ELEMENTS, AND PUT THE VALUE THERE IN A
GETSTG	LD	HL,STRING		;GET STRING AS THE BASE
	JR	GET100			;JOIN THE CODE
GETLNK	LD	HL,FLINK		;GET FLINK AS THE BASE
GET100	PUSH	BC			;SAVE BC FOR THE ADD
	LD	B,0			;MAKE BC A BYTE COUNT
	ADD	HL,BC			;HL NOW POINTS TO IT
	LD	A,(HL)			;A = HL[c]
	POP	BC			;RESTORE BC
	RET
;	ASSIGN THE C'th ELEMENT OF A STRING THE VALUE IN A
SETSTG	LD	HL,STRING		;GET STRING AS THE BASE
	JR	SET100			;JOIN THE CODE
SETLNK	LD	HL,FLINK		;GET FLINK AS THE BASE
SET100	PUSH	BC			;SAVE BC FOR THE ADD
	LD	B,0			;MAKE BC A BYTE OFFSET
	ADD	HL,BC			;HL POINT TO IT NOW
	LD	(HL),A			;HL[c] = A
	POP	BC			;RESTORE BC
	RET
;	PRINT THE MESSAGE IN DE AND QUIT WITH AN ERROR
SBORT2	CALL	PRTSTR			;DISPLAY THE MESSAGE
	JR	SBORT			;CLOSE THE FILE AND EXIT
;	ISSUE A SYSTEM ERROR MESSAGE FIRST AND SBORT
SBORT1	CALL	XERROR			;PRINT A SYSTEM MESSAGE
SBORT	LD	DE,LGFAIL		;LOGON FAILED MESSAGE
	CALL	PRTSTR			;PRINT IT FOR THE USER
	JP	SOU540
;	SURRENDER THE TERMINAL TO THE USER
QUTOUT	LD	DE,QUTMES		;TELL THEM WHAT WE ARE DOING
	CALL	PRTSTR
	JP	KERMIT			;GET A NEW COMMAND
;	CONTROL COMES HERE AT EOF
SOU400	LD	A,(ESFLG)		;DID WE DIE IN AN ESC SEQ
	OR	A
	JR	Z,SOU420		;JUMP IF NOT
	LD	DE,PREESC		;PRINT THE MESSAGE
	CALL	PRTSTR
	JR	SOU540			;CHECK STATE FLAGS
SOU420	LD	A,(CTLFLG)		;DID WE DIE IN A CTL SEQ
	OR	A
	JR	Z,SOU430		;JUMP IF NOT
	LD	DE,PRECTL		;PRINT THE MESSAGE
	CALL	PRTSTR
	JR	SOU540			;CHECK STATE FLAGS
SOU430	LD	A,(OPTFLG)		;CHECK FOR <CR> TYPE EOF
	OR	A
	JP	Z,KERMIT		;ON THIS ONE, GOTO KERMIT
	LD	DE,PREOPT
	CALL	PRTSTR
	JR	SOU540
SOU540	LD	A,(EXTFLG)		;CHECK FOR EXIT AT EOF
	OR	A			;IS IT SET
	JP	Z,KERMIT		;GOTO GET MORE COMMANDS IF NOT
	LD	A,(TAKFLG)		;CHECK IF TAKE ACTIVE
	OR	A
	JP	Z,KERMIT		;GOTO KERMIT IF NOT
	LD	DE,TFCB
	CALL	XCLOSE			;CLOSE THE TAKE FILE
	XOR	A			;TURN TAKE OFF
	LD	(TAKFLG),A
	JP	KERMIT			;GET A NET COMMAND
;	TABLE OF VALID CTRL ENTRIES <CR>, <LF>, ETC...
CTLTBL	DB	35
	DB	'ACK',6,254
	DB	'BEL',7,254
	DB	'BS',8,254
	DB	'CAN',24,254
	DB	'CR',13,254
	DB	'DC1',17,254
	DB	'DC2',18,254
	DB	'DC3',19,254
	DB	'DC4',20,254
	DB	'DEL',127,254
	DB	'DLE',16,254
DLY	EQU	250
	DB	'DLY*',DLY,254
	DB	'EM',25,254
	DB	'ENQ',5,254
	DB	'EOT',4,254
	DB	'ESC',27,254
	DB	'ETB',23,254
	DB	'ETX',3,254
	DB	'FF',12,254
	DB	'FS',28,254
	DB	'GS',29,254
	DB	'HT',9,254
	DB	'LF',10,254
	DB	'NAK',21,254
	DB	'NUL',0,254
	DB	'RS',30,254
	DB	'SI',15,254
	DB	'SO',14,254
	DB	'SOH',1,254
	DB	'SPA',32,254
	DB	'STX',2,254
	DB	'SUB',26,254
	DB	'SYN',22,254
	DB	'VS',31,254
	DB	'VT',11,254
	DEFB	0
GTSTRG	DEFS	10
;	GET ESCAPED OR CONTROL'D CHARACTER IF CONTENTS OF "A" SAY SO.
;	ALSO <CR>, <LF>, <FF>, ARE RECOGNIZED HERE FOR SEND AND RECEIVE.
;	HL MUST CONTAIN ADDRESS OF ROUTINE TO CALL FOR NEXT CHARACTER.
;	RETURNS NZ STATUS IF SECOND GET FAILED, OTHERWIZE RETURNS Z.
GTREAL	PUSH	HL			;SAVE THE REGS!
	PUSH	BC
	PUSH	DE
	CP	'\'			;IS IT AN ESCAPE SEQUENCE?
	JR	NZ,GT010		;JUMP IF IT ISN'T
	LD	A,1			;SET THE FLAG FOR A GET ERROR
	LD	(ESFLG),A
	CALL	GETFCH			;CALL THE SPECIAL ROUTINE
	JP	NZ,GT060		;QUIT IF END IS FOUND
	PUSH	AF
	XOR	A
	LD	(ESFLG),A
	POP	AF
	JP	GT060
GT010	CP	'^'			;IS IT A CONTROL SEQUENCE?
	JR	NZ,GT020		;JUMP IF IT ISN'T
	LD	A,1			;SET THE FLAG FOR A GET ERROR
	LD	(CTLFLG),A
	CALL	GETFCH			;CALL THE SPECIAL ROUTINE
	JP	NZ,GT060
	SUB	40H			;CONTROLIFY IT BY SUBTRACTING "@"
	PUSH	AF
	XOR	A
	LD	(CTLFLG),A
	POP	AF
	JP	GT050
WLDBUF	DEFS	6			;SAVE WILDCARDS HERE
GT020	CP	'<'			;IS IT <CR>,<LF>,<FF>, ETC...
	JP	NZ,GT050		;RETURN Z STATUS IF NOT
	LD	A,1			;SET THE STATE FLAG
	LD	(OPTFLG),A
	LD	HL,GTSTRG		;WHERE TO STORE THE STRING
GT023	CALL	GETFCH			;GET A CHARACTER
	JP	NZ,GT060		;QUIT ON AN ERROR
	CP	'>'			;IS IT THE END?
	JR	Z,GT026			;GO IF IT IS
	CALL	CPTAL			;MAKE IT A CAPITAL
	LD	(HL),A			;SAVE THE CHARACTER
	INC	HL			;MAKE ROOM FOR MORE
	JR	GT023			;GET SOME MORE
GT026	LD	(HL),0FFH		;IMPOSSIBLE CHARACTER AS EOL
	LD	HL,CTLTBL		;TOP OF THE TABLE
	LD	B,(HL)			;GET THE NUMBER OF ENTRIES
	INC	HL			;POINT AT THE FIRST CHAR
GT028	LD	DE,GTSTRG		;WHERE TO START OVER AT
GT030	LD	A,(DE)			;GET A CHARACTER
	CP	(HL)			;DO WE HAVE A MATCH?
	JR	NZ,GT040		;JUMP IF NOT
GT035	INC	HL			;POINT TO NEXT IN THE TABLE
	LD	A,(HL)			;GET THE NEXT CHAR
	CP	'0'			;IS IT 0-Z
	JR	C,GT037			;GOT A CONTROL SO END
	CP	'Z'			;IS IT NOT UPPER CASE?
	JR	NC,GT037		;NOT 0-Z SO MUST BE CONTROL
GT036	INC	DE			;POINT TO NEXT IN BUFFER
	JR	GT030			;CHECK SOME MORE
GT037	INC	DE			;POINT AT NEXT CHAR
	LD	C,A			;SAVE THE CHARACTER
	LD	A,(DE)
	CP	0FFH			;MUST BE THE TERMINATOR
	JR	NZ,GT040		;ERROR IF NOT
	LD	A,C			;RESTORE THE CHARACTER
	CP	DLY			;IS IT DLY?
	JP	Z,DELAY			;DO A DELAY SEQUENCE!
	PUSH	AF
	XOR	A
	LD	(OPTFLG),A
	POP	AF
	JP	GT050			;RETURN Z STATUS
GT040	LD	C,A			;SAVE THE CHARACTER
	LD	A,(HL)			;WILD CARD?
	CP	'*'			;ANYTHING GOES?
	JR	NZ,GT042		;NOPE SO CONTINUE
	LD	A,C
	LD	(WLDBUF),A		;SAVE IT IN THE BUFFER
	JR	GT035			;JOIN THE OK CODE FOR END CHK
GT042	LD	A,0FEH			;WHAT TO LOOK FOR
	PUSH	BC			;DON'T KILL B
	CPIR				;LOOK AHEAD FOR THE NEXT
	POP	BC			;RESTORE B
	DJNZ	GT028			;GO LOOK SOMEMORE
	JP	NOCODE			;PRINT A MESSAGE
DELAY	LD	A,(WLDBUF)		;GET THE CHARACTER
	SUB	48			;MAKE IT BINARY
	LD	L,A			;SAVE IT
	LD	H,0			;HL IN THE COUNT
	LD	C,30			;33.33 MILLISECS * 30 * HL = SECS
	LD	A,91
	RST	28H			;HL & A = HL * 30
	LD	H,L			;SHIFT IT ALL INTO HL
	LD	L,A			;HL = HL * 120
	LD	(TIMER),HL
	LD	A,29
	LD	C,8			;TASK SLOT # 8
	LD	DE,ALRMAD		;ADDRESS OF THE ALARM
	RST	28H
GT034	LD	HL,(TIMER)		;CHECK FOR ZERO YET
	LD	A,H
	OR	L
	JR	NZ,GT034		;LOOP UNTIL EXPIRES
	LD	A,1
	LD	(DLYFLG),A		;SET THE DELAY FLAG
GT050	CP	A			;SET Z STATUS
GT060	POP	DE			;RESTORE REGS
	POP	BC
	POP	HL
	RET				;RETURN TO THE CALLER
;
NOCODE	LD	DE,BADCD		;PRINT A MESSAGE
	CALL	PRTSTR
	XOR	A
	INC	A			;SET NZ STATUS
	JR	GT060
;	ALARM COUNTER
ALRMAD	DEFW	ALARM
TIMER	DEFW	0
ALARM	LD	HL,(TIMER)		;PREVIOUS TIMER VALUE
	DEC	HL			;DECREMENT IT
	LD	(TIMER),HL		;SAVE THE NEW VALUE
	LD	A,H			;IS IT ZERO YET
	OR	L
	RET	NZ			;RETURN IF NOT
	LD	A,32			;REMOVE THE ALARM
	RST	28H			;DOESN'T RETURN
;	AUTO BOOT COMMAND FILE CHECK
TKNAME	DEFM	'KERMIT/INI'
	DEFB	13
TKLEN	EQU	$-TKNAME
CHKTAK	LD	A,8			;CHECK FOR A KEY PRESSED
	RST	28H
	CP	13			;WAS IT <ENTER>?
	JR	Z,WAITCK		;GO WAIT UNTIL NO KEY PRESSES
	LD	DE,TFCB			;LOAD THE FCB ADDRESS
	LD	HL,TKNAME		;NAME OF THE FILE
	LD	BC,TKLEN		;LENGTH OF THE STRING
	LDIR
	LD	DE,TFCB			;GET IT AGAIN
	LD	HL,TBUF			;GET THE INPUT BUFFER
	LD	B,0			;256 BYTE LRL
	CALL	XOPEN			;OPEN THE FILE
	RET	NZ			;RETURN IF NO FILE FOUND
	LD	A,1			;SET THE TAKE COMMAND ACTIVE FLAG
	LD	(TAKFLG),A
	RET				;GO DO IT.
WAITCK	CALL	XKEY			;GET A KEY
	OR	A
	JR	NZ,WAITCK
	RET
;	CLEAR THE SPECIAL CHARACTER FLAGS
CLRFLG	PUSH	AF			;SAVE AF FOR NOW
	XOR	A			;ZERO INTO A
	LD	(CTLFLG),A		;RESET CONTROL STATE
	LD	(ESFLG),A		;RESET ESCAPE STATE
	POP	AF			;RESTORE AF
	RET				;RETURN TO THE CALLER
;	GET THE NEXT CHARACTER FROM THE BUFFER
GETFCH	PUSH	HL
	LD	HL,(SOUPTR)
	LD	A,(HL)
	INC	HL
	LD	(SOUPTR),HL
	CP	CR
	JR	Z,GTF010
	CP	A
	JR	GTF020
GTF010	CP	CR+1
GTF020	POP	HL
	RET
;	THE FOLLOWING FLAGS ARE STATE FLAGS FOR WHEN EOF OCCURS.
;	IF ANY ARE SET WHEN EOF OCCURS THAN AN ERROR HAS OCCURED.
INBUF	DEFS	102H			;FILE INPUT BUFFER
HSTCHR	DEFB	0			;TERMINATOR FROM THE HOST IN '*'
DLYFLG	DEFB	0			;WAS A DELAY INVOKED
CHRGOT	DEFB	0			;ACTUAL CHARACTER FROM THE FILE
;	PARSING OPTION FLAGS
CSEFLG	DEFB	0			;IGNORE CASE FLAG
SPTFLG	DEFB	0			;ECHOING OF SET OPTIONS IS ON
ECHFLG	DEFB	0			;IS ECHO OF SENT STRINGS ON
EXTFLG	DEFB	1			;EXIT AT EOF FLAG
;	EARLY EOF STATE FLAGS
ESFLG	DEFB	0			;ESCAPE CHARACTER SEQUENCE
CTLFLG	DEFB	0			;CONTROL CHARACTER SEQUENCE
SNDFLG	DEFB	0			;SEND STATE FLAG
RECFLG	DEFB	0			;RECEIVE SATE FLAG
MULFLG	DEFB	0			;MULTI-SEND STATE FLAG
OPTFLG	DEFB	0			;SET OPTIONS STATE FLAG
BADCD	DEFB	13
	DEFM	'Bad code in send string <xx> expected!'
	DEFW	240DH
NOECHO	DEFB	13
	DEFM	'Abort with no host echo!$'
QUTMES	DB	13,'Operation aborted!',CR,'$'
STOBIG	DEFB	13
	DEFM	'Receive string too big for buffer!'
	DEFW	240DH
LGFAIL	DEFB	13
	DEFM	'Logon failed, NO MATCH!!'
	DEFB	13
	DEFW	240DH
PREESC	DEFB	13
	DEFM	'Premature EOF!  Missing character following \'
	DEFW	240DH
PRECTL	DEFB	13
	DEFM	'Premature EOF!  Missing character following ^'
	DEFW	240DH
PREOPT	DEFB	13
	DEFM	'Premature EOF!  Missing > in <...> sequence'
	DEFW	240DH
	END

